---
title: Site compatibility for Firefox 3
slug: Mozilla/Firefox/Releases/3/Site_compatibility
tags:
  - Compatibility
  - Gecko
  - Web Development
---
<div>{{FirefoxSidebar}}</div>

<p>This page tries to give an overview of the changes between <a href="en/Gecko">Gecko</a> 1.8 and Gecko 1.9, that could possibly affect websites in their behavior or rendering.</p>

<p>See also <a href="en/Firefox_3_for_developers">Firefox 3 for developers</a>.</p>

<h2 id="Events">Events</h2>

<h3 id="Capturing_load_event_listeners">Capturing load event listeners</h3>

<p>In Gecko 1.8, it was not possible to set capturing load event listeners on images. In Gecko 1.9, this has been fixed by {{ Bug(234455) }}. But this can cause problems on websites that incorrectly have their event listeners set to capture the load event. See the discussion in {{ Bug(335251) }}. To fix this problem, the problematic page in question should not set a capturing load event listener.</p>

<p>For example, this:</p>

<pre class="eval">window.addEventListener('load', yourFunction, true);
</pre>

<p>should be changed into this:</p>

<pre class="eval">window.addEventListener('load', yourFunction, false);
</pre>

<p>For an explanation of how event capture works, see <a class="external" href="http://www.w3.org/TR/DOM-Level-2-Events/events.html#Events-flow-capture">DOM Level 2 Event capture</a></p>

<h3 id="preventBubble_has_been_removed"><code>preventBubble</code> has been removed</h3>

<p>In Gecko 1.8, the <code>preventBubble</code> method existed on events to prevent events from bubbling upwards. In Gecko 1.9 this method has been removed. Instead, you should use the standard <a href="en/DOM/event.stopPropagation">stopPropagation()</a>, which also works fine in Gecko 1.8. The patch in {{ Bug(330494) }} made this happen. See also {{ Bug(105280) }}.</p>

<h3 id="A_few_other_old_event_APIs_are_no_longer_supported">A few other old event APIs are no longer supported</h3>

<p><a href="/en-US/docs/Web/API/window.captureEvents"><code>window.captureEvents</code></a>, <a href="/en-US/docs/Web/API/window.releaseEvents"><code>window.releaseEvents</code></a> and <a href="/en-US/docs/Web/API/window.routeEvent"><code>window.routeEvent</code></a> are now considered deprecated since Gecko 1.9.</p>

<h2 id="DOM">DOM</h2>

<h3 id="WRONG_DOCUMENT_ERR"><code>WRONG_DOCUMENT_ERR</code></h3>

<p>Nodes from external documents should be cloned using <a href="/en-US/docs/Web/API/Document/importNode" title="The Document object's importNode() method creates a copy of a Node or DocumentFragment from another document, to be inserted into the current document later."><code>document.importNode()</code></a> (or adopted using <a href="/en-US/docs/Web/API/Document/adoptNode" title="Document.adoptNode() transfers a node from another document into the method's document. The adopted node and its subtree is removed from its original document (if any), and its ownerDocument is changed to the current document. The node can then be inserted into the current document."><code>document.adoptNode()</code></a>) before they
    can be inserted into the current document. For more on the <a href="/en-US/docs/Web/API/Node/ownerDocument" title="The Node.ownerDocument read-only property returns the top-level document object for this node."><code>Node.ownerDocument</code></a> issues, see the
    <a class="external" href="http://www.w3.org/DOM/faq.html#ownerdoc" rel="noopener">W3C DOM FAQ</a>.</p>

    <p>Firefox doesn't currently enforce this rule (it did for a while during the development of Firefox 3, but too many
    sites break when this rule is enforced). We encourage Web developers to fix their code to follow this rule for
    improved future compatibility.</p>

<h2 id="Ranges">Ranges</h2>

<h3 id="intersectsNode_has_been_removed"><code>intersectsNode</code> has been removed</h3>

<p>In Gecko 1.8 the function <code>intersectsNode</code> code be used to test if a node intersected a range. However the return values from this function were confusing and rarely useful and has therefore been removed in Gecko 1.9. Instead use the more precise and standard function <a href="en/DOM/range.compareBoundaryPoints">compareBoundaryPoints</a>. The patch in {{ Bug(358073) }} removed this function.</p>

<p>See the documentation for <a href="en/DOM/range.intersectsNode">intersectsNode</a> for how to use <code>compareBoundaryPoints</code> instead.</p>

<h3 id="compareNode_has_been_removed"><code>compareNode</code> has been removed</h3>

<p>In Gecko 1.8 the function <code>compareNode</code> code be used to test how a node intersected a range. However the return values from this function were confusing and rarely useful and has therefore been removed in Gecko 1.9. Instead use the more precise and standard function <a href="en/DOM/range.compareBoundaryPoints">compareBoundaryPoints</a>. The patch in {{ Bug(358073) }} removed this function.</p>

<p>See the documentation for <a href="en/DOM/range.compareNode">compareNode</a> for how to use <code>compareBoundaryPoints</code> instead.</p>

<h2 id="HTML">HTML</h2>

<h3 id="Many_bugs_in_the_.3Cobject.3E_have_been_fixed">Many bugs in the <code>&lt;object&gt;</code> have been fixed</h3>

<p><code>object</code> and <code>embed</code> elements no longer need a <code>type</code> attribute to render. Changing the <code>src</code> attribute (of <code>&lt;embed&gt;</code>) or the <code>data</code> attribute (of <code>&lt;object&gt;</code>) via JavaScript now works correctly. The Content-Type header sent by the server (if any) now takes precedence over the <code>type</code> attribute of an <code>&lt;object&gt;</code> element as per the HTML specification (this is not the case for <code>embed</code>).</p>
